package pomocov.utils;


// 2020-06-24. GRJ I'm unconvinced this is an improvement. Going back to Moran drift calculation for now
// TODO remove if not used
public class Bottleneck {

    static double[][] tableForVPop3 =
            {
                    {3.375, 3.375, 20.25, -3.295837},
                    {4.932912, 2.101031, 30.05733, -5.243829},
                    {6.598109, 1.732155, 42.07244, -6.972386},
                    {8.304738, 1.558127, 54.5769, -8.610448},
                    {10.02422, 1.456563, 67.22601, -10.19669},
                    {11.7466, 1.389759, 79.89523, -11.74908},
                    {13.46896, 1.342286, 92.55149, -13.27754},
                    {15.19069, 1.306682, 105.1911, -14.78815},
                    {16.91177, 1.278903, 117.8166, -16.28492},
                    {18.63234, 1.256566, 130.4314, -17.77063},
                    {20.3525, 1.238173, 143.0379, -19.24732},
                    {22.07236, 1.222735, 155.6382, -20.71648},
                    {23.79198, 1.209572, 168.2334, -22.17929},
                    {25.51141, 1.198198, 180.8248, -23.63664},
                    {27.23069, 1.18826, 193.4129, -25.08926},
                    {28.94984, 1.179492, 205.9984, -26.53775},
                    {30.6689, 1.171692, 218.5818, -27.98259},
                    {32.38786, 1.1647, 231.1633, -29.42419},
                    {34.10676, 1.158394, 243.7433, -30.86288},
                    {35.8256, 1.152671, 256.3219, -32.29896}
            };

    static double [] bottleneck1ForVPop3 = {0.666666666666667, 0.0, 0.0, 0.333333333333333};

    static double [] bottleneck2ForVPop3 = {0.444444444444444, 0.222222222222222, 0.222222222222222, 0.111111111111111};

    static double [] bottleneck3ForVPop3 = {0.296296296296296, 0.444444444444444, 0.222222222222222, 0.037037037037037};



    static public double [] bottleneckForVPop3(double b) {
        double [] probs = new double[4];
        if (b <= 2.0) {
            for (int i = 0; i < 4; i++) {
                probs[i] = (2.0 - b) * bottleneck1ForVPop3[i]  +  (b - 1.0) * bottleneck2ForVPop3[i];
            }
        } else if (b <= 3.0) {
            for (int i = 0; i < 4; i++) {
                probs[i] = (3.0 - b) * bottleneck2ForVPop3[i]  +  (b - 2.0) * bottleneck3ForVPop3[i];
            }
        } else {
            double pp0;
            double pp1;
            double pp2;
            double pp3;
            double bb = 0.5 * (b - 3.0);
            int below = (int) Math.floor(bb);
            if (below < 19) {
                int above = below + 1;
                pp0 = (above - bb) * tableForVPop3[below][0]  +  (bb - below) * tableForVPop3[above][0];
                pp1 = (above - bb) * tableForVPop3[below][1]  +  (bb - below) * tableForVPop3[above][1];
                pp2 = (above - bb) * tableForVPop3[below][2]  +  (bb - below) * tableForVPop3[above][2];
                pp3 = (above - bb) * tableForVPop3[below][3]  +  (bb - below) * tableForVPop3[above][3];
            } else {
                pp0 = tableForVPop3[19][0] + (bb - 19) * (tableForVPop3[19][0] - tableForVPop3[18][0]);
                pp1 = tableForVPop3[19][1] + (bb - 19) * (tableForVPop3[19][1] - tableForVPop3[18][1]);
                pp2 = tableForVPop3[19][2] + (bb - 19) * (tableForVPop3[19][2] - tableForVPop3[18][2]);
                pp3 = tableForVPop3[19][3] + (bb - 19) * (tableForVPop3[19][3] - tableForVPop3[18][3]);
            }
            probs[0] = 1.0 / pp0;
            probs[1] = Math.pow(pp1, -2.0/3.0);
            probs[2] = Math.pow(pp2, -0.5);
            probs[3] = Math.exp(pp3);
        }
        return probs;
    }



    /* R code

make.drift.rate.matrix <- function(N) {
	R = matrix(0, nrow=N+1, ncol=N+1)
	for (ii in 2:N) {
		i = ii-1
		x = i*(N-i)/(N*N)
		R[ii,ii-1] = x
		R[ii,ii+1] = x
	}
	for (ii in 2:N) {
		R[ii,ii] = -R[ii,ii+1] -R[ii,ii-1]
	}
	R
}


binom.n.Probs  <- function(n) {
  P = matrix(0, nrow=n+1, ncol=n+1)
  P[1, 1] = 1
  P[n+1, n+1] = 1
	for (i in 1:(n-1)) {
		P[, i+1] = dbinom(0:n, n, i/n)
	}
  P
}


Podd.to.P3 <- function(Podd) {
	v = nrow(Podd)
	stopifnot(v %% 2 == 0)
	m = v / 2
	s = m - 1
	P3 = matrix(0, nrow=4, ncol=4)
	P3[1,1] = Podd[1,1]
	P3[1,2] = sum(Podd[1,2:m]) / s
	P3[1,3] = sum(Podd[1,(m+1):(2*m-1)]) / s
	P3[1,4] = Podd[1,2*m]
	P3[2,2] = sum(Podd[2:m,2:m]) / s
	P3[2,3] = sum(Podd[2:m,(m+1):(2*m-1)]) / s
	P3[3,2] = sum(Podd[(m+1):(2*m-1),2:m]) / s
	P3[3,3] = sum(Podd[(m+1):(2*m-1),(m+1):(2*m-1)]) / s
	P3[4,1] = Podd[2*m,1]
	P3[4,2] = sum(Podd[2*m,2:m]) / s
	P3[4,3] = sum(Podd[2*m,(m+1):(2*m-1)]) / s
	P3[4,4] = Podd[2*m,2*m]
	P3
}



print.array <- function(xxx) {
	cat("{\n")
	for (m in 1:nrow(xxx)) {
		cat("{", xxx[m,1], ", ", xxx[m,2], ", ", xxx[m,3], ", ", xxx[m,4], "}")
    if (m < nrow(xxx)) {
			cat(",\n")
	} else {
		cat("\n}\n")
    }
	}
}



mms = 1:20
bottleneck.range = 2*mms  + 1
res = matrix(0, nrow = length(mms), ncol=4)
for (m in mms) {
	res[m,] = t(Podd.to.P3(binom.n.Probs(bottleneck.range[m])))[2,]
}

xxx = res
xxx[,1] = xxx[,1]^-1
xxx[,2] = xxx[,2]^-1.5
xxx[,3] = xxx[,3]^-2
xxx[,4] = log(xxx[,4])


print.array(xxx)












     */

}
